/* 
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.felix.framework;

import org.apache.felix.framework.monitor.MonitoringService;
import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceRegistration;

class MonitorServiceActivator implements BundleActivator {

    private final Felix m_felix;
    private ServiceRegistration m_reg = null;
    

    MonitorServiceActivator(Felix felix) {
        m_felix = felix;
    }

    public void start(BundleContext context) throws Exception {
        m_felix.getMonitorService().start();
        m_reg = context.registerService(
                MonitoringService.class.getName(),
                m_felix.getMonitorService(), null);
    }

    public void stop(BundleContext context) throws Exception {
        m_reg.unregister();
        m_felix.getMonitorService().destroy();
    }
}
